/*******
 * 作者:陈浩
 * 创建时间:2019年10月31日
 * *****/
(function(window) { //javascript 闭包
    if (!Array.isArray) {
        Array.isArray = function(data) {
            return data != null && data.length != null;
        }
    }

    window.ObjectSerialize = function(obj, isNoDecoding) {
        var result = "";
        var index = 0;
        for (var pro in obj) {
            if (index != 0)
                result += "&";
            index++;
            if (obj[pro] != null) {
                result += pro + "=" + (isNoDecoding ? encodeURI(obj[pro]) : encodeURIComponent(obj[pro]));
            } else {
                result += pro + "=";
            }
        }
        return result;
    }

    window.getParams = function(url) {
        var query = getQueryString(url);
        return parseQueryString(query);
    }

    window.parseQueryString = function(queryString) {
        var result = {};
        if (queryString) {
            var paramAndValues = queryString.split("&");
            for (var i = 0; i < paramAndValues.length; i++) {
                var paramAndValue = paramAndValues[i];
                var temp = paramAndValue.split("=");
                if (temp[0] != "") {
                    var data = temp[1];
                    try {
                        data = decodeURIComponent(temp[1]);
                    } catch (e) {}
                    if (data === "false")
                        data = false;
                    if (data === "true")
                        data = true;
                    result[temp[0]] = data;
                }
            }
            if (result.token)
                delete result.token;
        }
        return result;
    }

    window.getQueryString = function(url) {
        if (url == null)
            url = location.href;
        if (url.indexOf('?') >= 0)
            return url.substring(url.indexOf('?') + 1);
        return "";
    }

    window.getPageAddress = function(url) {
        if (url == null)
            url = location.href;
        if (url.indexOf('?') >= 0)
            return url.substring(0, url.indexOf('?'));
        return url;
    }

    window.replaceQueryString = function(url, options, isOnlyQueryString, isNoDecoding) {
        var params = getParams(url);
        var setting = extend(params, options, { _: new Date().getTime() }); //如果不是ajax提交时,调用此函数也支持动态时间参数
        var queryString = ObjectSerialize(setting, isNoDecoding);
        if (isOnlyQueryString) {
            return queryString;
        }
        var address = getPageAddress(url);
        if (queryString)
            return address + "?" + queryString;
        return address;
    }

    window.decodeUnicode = function(data) {
        if (data && data.indexOf("&#") == 0) {
            var con = data.replace("&#", "0");
            var result = parseInt(con);
            return String.fromCharCode(result);
        } else {
            return data;
        }
    }
    window.encodeUnicode = function() {

    }

    /**
     * 格式化字符串
     * @param data 需要被格式化的数据,可以是Object对象也可以是数组,如果是object对象,格式化字符串的格式为 {属性名称},如果是数组或多个参数,则格式化字符串为 {0} {1}
     */
    window.String.prototype.urlFormat = function(data, withoutEncoding) {
        var args = arguments;
        if (typeof args[0] == "object" || typeof args[0] == "function") //对对象和数组进行支持
            args = args[0];
        return this.replace(/\{(\w+)\}/ig, function(m, i) {
            var result = args[i];
            if (result == null) {
                if (typeof i == "string")
                    result = args[i.toLowerCase()];
            } //如果出现大小写问题,一律支持小写
            if (result == null)
                result = "";
            if (!withoutEncoding)
                result = encodeURI(decodeURI(result)); //对url进行编码和解码的支持
            return result;
        });
    };

    /**
     * 格式化字符串
     * @param data 需要被格式化的数据,可以是Object对象也可以是数组,如果是object对象,格式化字符串的格式为 {属性名称},如果是数组或多个参数,则格式化字符串为 {0} {1}
     */
    window.String.prototype.format = function(data, nofindedempty) {
        var args = arguments;
        if (typeof args[0] == "object" || typeof args[0] == "function") //对对象和数组进行支持
            args = args[0];
        return this.replace(/\{(\w+)\}/ig, function(m, i) {
            var result = args[i];
            if (result == null && typeof i == "string") //如果出现大小写问题,一律支持小写
                result = args[i.toLowerCase()];
            if (result == null || result == "undefined") {
                if (nofindedempty) //如果找不到数据，则为空
                    result = "";
                else
                    result = "{" + i + "}";
            }
            return result;
        });
    };

    if (!window.String.prototype.trim)
        window.String.prototype.trim = function() {
            return this.replace(/^\s+|\s+$/gm, '');
        };


    /**
     * 格式化字符串
     * @param str 格式化字符串
     * @param data 需要被格式化的数据,可以是Object对象也可以是数组,如果是object对象,格式化字符串的格式为 {属性名称},如果是数组或多个参数,则格式化字符串为 {0} {1}
     * @returns {*|String|Boolean} 格式化结果
     */
    window.String.Format = function(str, data) {
        var args = arguments;
        if (typeof str == "string") {
            if (typeof args[1] == "object") { //如果是对象,则直接按属性进行处理
                return str.format(args[1]);
            } else {
                var data = Array.prototype.slice.call(args, 1);
                return String.prototype.format.call(str, data); // format.foramt(data);//   args.slice(1));  不能直接调这个
            }
        } else {
            throw Error("字符串格式化第一个参数是待格式化的格式内容");
        }
    };


    if (!("console" in window))
        window.console = {
            log: function() {}
        };

    Date.prototype.format = function(fmt) { //author: meizz
        var o = {
            "M+": this.getMonth() + 1, //月份
            "d+": this.getDate(), //日
            //   "h+":  (this.getHours()/12>1)?"下午 ":"上午 "+ this.getHours()%12,               //小时
            "H+": this.getHours(), //24小时
            "m+": this.getMinutes(), //分
            "s+": this.getSeconds(), //秒
            "q+": Math.floor((this.getMonth() + 3) / 3), //季度
            "S+": this.getMilliseconds() //毫秒
        };
        if (/(y+)/.test(fmt))
            fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
        for (var k in o)
            if (new RegExp("(" + k + ")").test(fmt)) {
                var temp = "00" + o[k];
                fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : temp.substr(temp.length - RegExp.$1.length));
            }
        return fmt;
    }
    Date.PerSecondTick = 1000;
    Date.PerMinuteTick = Date.PerSecondTick * 60;
    Date.PerHourTick = Date.PerMinuteTick * 60;
    Date.PerDayTick = Date.PerHourTick * 24;
    Date.prototype.addSeconds = function(second) {
        if (second != 0)
            this.setTime(this.getTime() + second * Date.PerSecondTick);
        return this;
    }
    Date.prototype.addMinutes = function(minute) {
        if (minute != 0)
            this.setTime(this.getTime() + minute * Date.PerMinuteTick);
        return this;
    }
    Date.prototype.addHours = function(hour) {
        if (hour != 0)
            this.setTime(this.getTime() + hour * Date.PerHourTick);
        return this;
    }
    Date.prototype.addDays = function(day) {
        if (day != 0)
            this.setTime(this.getTime() + day * Date.PerDayTick);
        return this;
    }
    Date.prototype.addMonths = function(month) {
        if (month != 0) {
            var m = this.getMonth() + month;
            var y = parseInt(m / 12);
            this.addYears(y);
            this.setMonth(m % 12);
        }
        return this;
    }
    Date.prototype.addYears = function(year) {
        if (year != 0)
            this.setYear(this.getFullYear() + year);
        return this;
    }


    /**
     * 判断一个变量是否为数组
     * @param obj 需要判断的变量
     * @returns 是否是一个数组
     */
    window.isArray = function(obj) {
        var str = Object.prototype.toString.call(obj);
        return str === '[object Array]' || str === '[object Array Iterator]';
    };

    /**
     * 判断一个变量是否为对象,但不是数组
     * @param obj 需要判断的变量
     * @param strict 是否需要判断其是不是数组,如果为false,则不判断,如果为true,则需要判断
     * @returns 是否是一个对象
     */
    window.isObject = function(obj, strict) {
        return obj && typeof obj === 'object' && (!strict || !isArray(obj));
    };

    var doCopy = function(copy, original, recursive) {
        var value, key;
        if (typeof copy !== 'object') {
            copy = {};
        }
        for (key in original) {
            if (original.hasOwnProperty(key)) {
                value = original[key];
                if (isObject(value, true) && typeof value.nodeType !== 'number') {
                    copy[key] = recursive ? doCopy(copy[key] || {}, value, recursive) : value;
                } else {
                    copy[key] = original[key];
                }
            }
        }
        if (key == null && original != null && original.test) { //正则表达式支持
            copy = original;
        }
        return copy;
    };

    /**
     * 抄自highcharts,用于融合对象
     * merge(true,ret,defaults,options...)
     * merge(defaults,options...)
     * @returns 融合后的对象
     */
    window.merge = function() {
        var i,
            args = arguments,
            len,
            ret = {};
        if (args[0] === true) {
            ret = args[1];
            args = Array.prototype.slice.call(args, 2);
        }
        len = args.length;
        for (i = 0; i < len; i++) {
            ret = doCopy(ret, args[i], true);
        }
        return ret;
    };
    /**
     * 扩展
     * extend(ret,defaults,options...)
     * @returns {any}
     */
    window.extend = function() {
        var args = arguments;
        var ret = args[0];
        args = Array.prototype.slice.call(args, 1);
        var len = args.length;
        for (var i = 0; i < len; i++) {
            ret = doCopy(ret, args[i], false);
        }
        return ret;
    };

    window.params = getParams();
    window.debug = function() {
        var time = new Date().format("[yyyy-MM-dd HH:mm:ss,SSS]");
        var methods = ["log", "error", "info", "warn"];
        for (var i in methods) {
            //因控制台本身打印可以定位代码位置，所以我们要应bind来告诉调用的方法，本身就是控制台的实现，以去掉因多个方法造成的调用堆栈深度而引发的代码位置错误问题
            this[methods[i]] = (params.debug && console[methods[i]] ? console[methods[i]].bind(window.console, time) : function() {});
        }
        var methods = ["time", "timeEnd"];
        for (var i in methods) {
            //因控制台本身打印可以定位代码位置，所以我们要应bind来告诉调用的方法，本身就是控制台的实现，以去掉因多个方法造成的调用堆栈深度而引发的代码位置错误问题
            this[methods[i]] = (params.debug && console[methods[i]] ? console[methods[i]].bind(window.console) : function() {});
        }
        return this;
    }
    var CallbackFactory = {};
    /**
     * 全局延迟委托
     * @param callback 需要延迟调用的方法
     * @param timetout  延迟时间
     */
    CallbackFactory.callback = function(callbackhandler, timetout) {
        if (callbackhandler.name) {
            this.undoCallback(callbackhandler);
            var args = [CallHandler, timetout, callbackhandler];
            for (var i = 2; i <= arguments.length; i++) {
                args.push(arguments[i]);
            }
            CallbackFactory[callbackhandler.name] = setTimeout.apply(window, args);
        } else {
            setTimeout.apply(window, arguments);
            debug().error("无法注册匿名方法管理，如果需要进行管理，请先对callback的函数进行命名");
        }
    }
    var CallHandler = function(callback) {
            delete CallbackFactory[callback.name];
            var args = [];
            for (var i = 1; i <= arguments.length; i++) {
                args.push(arguments[i]);
            }
            callback.apply(this, args);
        }
        /**
         * 全局撤销委托
         * @param callback 需要被撤销的方法
         */
    CallbackFactory.undoCallback = function(callbackhandler) {
        if (callbackhandler.name) {
            if (CallbackFactory[callbackhandler.name]) {
                debug().warn("已经撤销了[{name}]上次回调申请".format(callbackhandler));
                clearTimeout(CallbackFactory[callbackhandler.name]);
                CallbackFactory[callbackhandler.name] = null;
                delete CallbackFactory[callbackhandler.name];
            }
        } else {
            debug().error("无法注册匿名方法管理，如果需要进行管理，请先对callback的函数进行命名");
        }
    }
    window.CallbackFactory = CallbackFactory;
})(window);