/**
 * jquery从1.9.2起去掉了浏览器的判断支持
 * 所以在这边做扩展支持
 * create by ch 2019-11-05
 */
jQuery.extend({
    uaMatch: function(ua) {
        ua = ua.toLowerCase();
        var rwebkit = /(webkit)[ \/]([\w.]+)/,
            ropera = /(opera)(?:.*version)?[ \/]([\w.]+)/,
            rmsie = /(msie) ([\w.]+)/,
            rmozilla = /(mozilla)(?:.*? rv:([\w.]+))?/;
        var match = rwebkit.exec(ua) ||
            ropera.exec(ua) ||
            rmsie.exec(ua) ||
            ua.indexOf("compatible") < 0 && rmozilla.exec(ua) || [];
        return { browser: match[1] || "", version: match[2] || "0" };
    },

    sub: function() {
        function jQuerySub(selector, context) {
            return new jQuerySub.fn.init(selector, context);
        }
        jQuery.extend(true, jQuerySub, this);
        jQuerySub.superclass = this;
        jQuerySub.fn = jQuerySub.prototype = this();
        jQuerySub.fn.constructor = jQuerySub;
        jQuerySub.sub = this.sub;
        jQuerySub.fn.init = function init(selector, context) {
            if (context && context instanceof jQuery && !(context instanceof jQuerySub)) {
                context = jQuerySub(context);
            }

            return jQuery.fn.init.call(this, selector, context, rootjQuerySub);
        };
        jQuerySub.fn.init.prototype = jQuerySub.fn;
        var rootjQuerySub = jQuerySub(document);
        return jQuerySub;
    },

    browser: {}
});


browserMatch = jQuery.uaMatch(window.navigator.userAgent);
if (browserMatch.browser) {
    jQuery.browser[browserMatch.browser] = true;
    jQuery.browser.version = browserMatch.version;
}
// Deprecated, use jQuery.browser.webkit instead
if (jQuery.browser.webkit) {
    jQuery.browser.safari = true;
}
var matchs = {
    android: /(android)(?:.*? rv:([\w.]+))?/,
    ios: /(mac os x)(?:.*? rv:([\w.]+))?/,
    weixin: /(micromessenger)(?:.*? rv:([\w.]+))?/,
    qq: /(mqqbrowser)(?:.*? rv:([\w.]+))?/,
    huawei: /(huawei)(?:.*? rv:([\w.]+))?/,
    xiaomi: /(xiaomi)(?:.*? rv:([\w.]+))?/, ///((xiaomi)|(blackshark))(?:.*? rv:([\w.]+))?/,
    blackshark: /(blackshark)(?:.*? rv:([\w.]+))?/,
    vivo: /(vivo)(?:.*? rv:([\w.]+))?/,
    oppo: /(pcg)(?:.*? rv:([\w.]+))?/,
    samsung: /(samsung)(?:.*? rv:([\w.]+))?/,
    sony: /(sony)(?:.*? rv:([\w.]+))?/,
    nokia: /(nokia)(?:.*? rv:([\w.]+))?/,
    htc: /(htc)(?:.*? rv:([\w.]+))?/,
    zte: /(zte)(?:.*? rv:([\w.]+))?/,
    lenovo: /(lenovo)(?:.*? rv:([\w.]+))?/,
    zuk: /(zuk)(?:.*? rv:([\w.]+))?/,
    iphone: /(iphone)(?:.*? rv:([\w.]+))?/,
    version: /(version)[ \/]([\w.]+)/,
    mobile: /(mobile)(?:.*? rv:([\w.]+))?/
};
for (var key in matchs) {
    var match = matchs[key].exec(window.navigator.userAgent.toLowerCase()) || [];
    if (match[1]) {
        jQuery.browser[key] = true;
    }
    if (key == "version") {
        jQuery.browser[key] = match[2] || jQuery.browser[key];
    }
}


/**
 * 下载app
 * @param options
 */
jQuery.extend({
    downloadApp: function(options) {
        if (jQuery.browser.ios || jQuery.browser.android) {
            var defaults = {
                    phones: ["iphone", "weixin", "qq", "huawei", "vivo", "xiaomi", "blackshark", "oppo", 'ios', "android"],
                    "iphone": { id: 1471474755 },
                    "weixin": { id: "com.xn.ships66", type: "qq" },
                    "qq": { id: "com.xn.ships66", type: "qq" },
                    "android": { id: "com.xn.ships66", type: "qq" },
                    "huawei": { id: "com.xn.ships66" },
                    "xiaomi": { id: "com.xn.ships66" },
                    "blackshark": { id: "com.xn.ships66" },
                    "vivo": { id: "com.xn.ships66" },
                    "oppo": { id: "com.xn.ships66" },
                    "ios": { id: "com.xn.ships66" },
                } //,"samsung":null,"sony":null,"nokia":null,"htc":null,"zte":null,"lenovo":null,"zuk":null}
            var setting = jQuery.extend({}, defaults, options);
            for (var i in setting.phones) {
                var key = setting.phones[i];
                if (jQuery.browser[key]) {
                    var id = setting[key].id;
                    if (key == "iphone") {
                        window.location.href = "https://apps.apple.com/cn/app/%E8%88%B9%E9%A1%BA%E7%BD%91/id" + id;
                    } else {
                        if (setting[key].type == "qq") {
                            window.location.href = 'https://sj.qq.com/myapp/detail.htm?apkName=' + id;
                        } else {
                            window.location.href = "market://details?id=" + id;
                        }
                    }
                    return true;
                }
            }
        }
        return false;
    }
});
/**
 * jquery从1.9.+起去掉了live的支持
 * 所以在这边做扩展支持
 * create by ch 2019-11-05
 */
jQuery.fn.extend({
    live: function(types, data, fn) {
        jQuery(this.context).on(types, this.selector, data, fn);
        return this;
    }
});